function [X, Y]=coupled_tent(LEN,EPS)
%Generates non linearly coupled tent maps
% Inputs - 
%   LEN - length of input series
%   EPS - degree of coupling
%Outputs-
%   X - dependent tent map
%   Y - independent tent map 

% f1 = inline('2*x');
% f2 = inline('2-2*x');
%
%
%
% Aditi Kathpalia, Nithin Nagaraj, NIAS, October 2017

M = 2;
%M=1 depends only on past of itself(independent tent map), M=2 depends on past of itself and past of M=1 (dependent tent map)

ITER = LEN+2000;            % increasing the number of iterations by 2000 to remove transients at the end
TRANS = 10;
PP = 0.49999;

X_gen = zeros(M,ITER);
%EPS=0.3;                 %Degree of coupling

X_gen(:,1) = rand(M,1);

for j = 1:M;
    xx = X_gen(j,1);
        
end

for i = 2:ITER;
    
    for j = 1:M
        if j>1
            xx = EPS*X_gen(j-1,i-1)+ (1-EPS)*X_gen(j,i-1);      %High dependence on previous state (M) if EPS is greater
        else
            xx=X_gen(j,i-1);        %Tent map only on past of itself if M=1
        end
            X_gen(j,i) = UpdateTent(xx);
         
    end
end


Y=X_gen(1,2001:2000+LEN)';               %Independent tent map (after removing transients)
X=X_gen(2,2001:2000+LEN)';               %Dependent tent map (after removing transients)

end
